//Data Visualization Proj3: Correlation, by Song Gao

 //Global Variables
 String gSPLFilename= "2008_2012Monthly_electiondebate_checkouts.csv";
 String gNYTFilename= "2008_2012Monthly_NYT_articles.csv";
 int[][] SPLDataMatrix=new int[5][12];
 int[][] NYTDataMatrix=new int[5][12];
 int borderPixels=50;
 PFont gFont1=createFont("Georgia", 25, false);
 PFont gFont2=createFont("Helvetica", 30);
 int indX=0;
 int indY=0;
 String strSPLValue=null;
 String strNYTValue=null;
 int maxSPLData=700;
 int maxNYTData=700;
 
 int SPLValue=548;
 int NYTValue=345;
 
 // Background
float gfHMargin = 20.0f;
float gfVMargin = 60.0f;
int gnBgBoxGradientLevel = 20;
int gnYearStart = 2008;
int gnYearEnd   = 2012;

String baseURL = "http://api.nytimes.com/svc/search/v2/articlesearch";
String apiKey = "a77d92c67426f9be610fe3a23c0e3bb5:4:68823567";

void getNYTData()
{
  String[] year = {"2008","2009","2010","2011","2012"};
  String[] month = {"","1","2","3","4","5","6","7","8","9","10","11","12"};
  String[] word = {"election", "debate"};
  for (int i = 0; i < 5; i++){
    for (int j = 1; j <= 12; j++){
      String beginDate = "";
      String endDate = "";
      beginDate += year[i];
      endDate += year[i];
      if (j <= 9){
        beginDate += "0";
        endDate += "0";
      }
      beginDate += month[j];
      endDate += month[j];
      beginDate += "01";
      if (j == 1 || j == 3 || j == 5 || j == 7 || j == 8 || j == 10 || j == 12){
        endDate += "31";
      }
      else if (j != 2){
        endDate += "30";
      }
      else{
        if (i == 3){
          endDate += "29";
        }
        else{
          endDate += "28";
        }
      }
      String request = baseURL + ".json?q=japan&begin_date=" + beginDate + "&end_date=" + endDate + "&api-key=" + apiKey;
      //println(request);
      JSONObject result = loadJSONObject(request);
      JSONObject response = result.getJSONObject("response");
      JSONObject meta = response.getJSONObject("meta");
      int total = meta.getInt("hits");
      println(year[i] + "," + month[j] + "," + total);
}
  }
}

void setup() {
  //getNYTData
  getNYTData();
  // display
  size(800, 600);
  smooth();
  colorMode(HSB, 360, 100, 100);
  background(20,20,5);
 
 //Load Saved Data from local files
    //Seattle Public Library checkouts
    String [] textSPL = loadStrings(gSPLFilename); 
      println("Seattle Public Library");
    for (int row=1; row<textSPL.length; row++) {
      String SPLData[] = split(textSPL[row], ","); // split the data in each line from comma
      SPLDataMatrix[PApplet.parseInt(SPLData[0])-2008][PApplet.parseInt(SPLData[1])-1]=PApplet.parseInt(SPLData[2]);
      println("Year: "+SPLData[0]+" Month: "+SPLData[1]+" Count: "+SPLDataMatrix[PApplet.parseInt(SPLData[0])-2008][PApplet.parseInt(SPLData[1])-1]) ;
  }
   //New York Times articles
   String [] textNYT = loadStrings(gNYTFilename); 
     println("New York Times");
    for (int row=1; row<textNYT.length; row++) {
      String NYTData[] = split(textNYT[row], ","); // split the data in each line from comma
      NYTDataMatrix[PApplet.parseInt(NYTData[0])-2008][PApplet.parseInt(NYTData[1])-1]=PApplet.parseInt(NYTData[2]);
      println("Year: "+NYTData[0]+" Month: "+NYTData[1]+" Count: "+NYTDataMatrix[PApplet.parseInt(NYTData[0])-2008][PApplet.parseInt(NYTData[1])-1]) ;
  }
}


void draw()
{
  //title 
  textFont(gFont1);
  colorMode(RGB,255,255,255);
  fill(255,255,255);
  smooth();
  textAlign(LEFT, CENTER);
  text("Temporal Trends of 'election' and 'debates'", width/4, borderPixels-20);
  
//   // background gradient
//    colorMode(HSB, 360, 100, 100);
//          float fBgBoxWidth = (width-borderPixels*4)/float(gnYearEnd-gnYearStart+1);
//          float fBgBoxHeight = (height-borderPixels*2)/2.0f;          
//          for (int x=0; x<gnYearEnd-gnYearStart+1; x++ )  {
//              fill(0,0,82.4);
//              rect((width-4*borderPixels)/4*(x-2008)+2.5*borderPixels, height-10, (width-2*borderPixels)/60, -(height-borderPixels)/2);
//  }
  
  //setting the color and local variables for the bar charts
 colorMode(HSB, 360, 100, 100);
  int SPLcolorH = 355;
  float  SPLcolorS = 80;
  float  SPLcolorB = 100;
    int  NYTcolorH = 55;
  float  NYTcolorS = 80;
  float  NYTcolorB = 100;
  int splHeightSize=(height-3*borderPixels)/2;
  int nytHeightSize=(height-3*borderPixels)/2;
  float barWidth=(width-2*borderPixels)/60;
  
  //darw the SPL data
 for (int i=0; i<5; i++) {  // row: yearly
        for (int j=0; j<12; j++) {  // column: monthly 
          fill(SPLcolorH,SPLcolorS,SPLcolorB);
          int splHeight=SPLDataMatrix[i][j]*splHeightSize/maxSPLData;
          rect(2.5*borderPixels+barWidth*(i*12+j), borderPixels+(height-borderPixels)/2, barWidth, -splHeight);

          textSize(35);
          //text("Seattle Public Library",borderPixels-30, borderPixels*1.5);
          text("SPL",30, height/2-2*borderPixels);
  
          colorMode(HSB, 360, 100, 100);      
          // below graph NYT
          fill(NYTcolorH,NYTcolorS,NYTcolorB);
          text("NYT",30, height/2+2*borderPixels);
          int nytHeight=NYTDataMatrix[i][j]*nytHeightSize/maxNYTData;
          rect(2.5*borderPixels+barWidth*(i*12+j), borderPixels+(height-borderPixels)/2-20, barWidth, nytHeight*0.8);
        }
  }

//live mode to show the numbers
float circleX = 58;
float circleY = borderPixels+(height-borderPixels)/2;
float radius = 106;
fill(NYTcolorH,NYTcolorS,NYTcolorB-10);
arc(circleX, circleY-20, radius, radius, 0, PI);
//another half above circle
fill(SPLcolorH,SPLcolorS,SPLcolorB-10);
arc(circleX, circleY-20, radius, radius, PI, TWO_PI);
           
    //interaction with real values when hover the mouse
    if(mouseX > 2.5*borderPixels && mouseX < (width-20) && mouseY > 2.5*borderPixels && mouseY < (height-2*borderPixels)){
       int indexHeight=floor((mouseX-2.5*borderPixels)/barWidth);
       println("mouseX: "+mouseX+"; mouseY: "+mouseY+"; Value: "+indexHeight);
       int indexYear=floor(indexHeight/12);
       int indexMonth=indexHeight%12;
       println("Year: "+indexYear+" Month:"+indexMonth);
       SPLValue=SPLDataMatrix[indexYear][indexMonth];
       NYTValue=NYTDataMatrix[indexYear][indexMonth];
    }
          colorMode(RGB,255,255,255);
          fill(255,255,255);
          gFont2 = createFont("Helvetica",30, false);  
          textFont(gFont2);
          textAlign(LEFT, CENTER);
          text(SPLValue,30, borderPixels+(height-borderPixels)/2-45);
          text(NYTValue,30, borderPixels+(height-borderPixels)/2);
         
//axis labels
      textAlign(LEFT, LEFT);
      textSize(12);
      colorMode(RGB,255,255,255);
      fill(255,255,255);
      /*for (int monthLabel=1;monthLabel<61;monthLabel++){
        text(monthLabel,(width-2.5*borderPixels)/60*monthLabel+2.3*borderPixels,height-10); 
      }
      */
      textSize(25);
      for (int yearLabel=2008;yearLabel<=2013;yearLabel++){
        //rect((width-2.5*borderPixels)/5*(yearLabel-2008)+2.5*borderPixels, height-10, barWidth*12, height);
        text(yearLabel,(width-2.5*borderPixels)/5*(yearLabel-2008)+2.5*borderPixels,height-10);
        // time axis break lines among years
     
}

     save("SPLNYTcorrelation.png");
}

      
